package com.daeucna.board.interceptor;
 
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
 
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import lombok.extern.slf4j.Slf4j;
 
@Slf4j
public class BaseInterceptor implements HandlerInterceptor {
 
    @Override
    public boolean preHandle( HttpServletRequest request
                            , HttpServletResponse response
                            , Object handler ) throws Exception {
        
         if (log.isDebugEnabled()) {
             log.debug("===== ===== ===== ===== =====    START     ===== ===== ===== ===== =====");
             log.debug("RequestURI:[{}]", request.getRequestURI());
         }
        
        return true;
    }
 
    @Override
    public void postHandle( HttpServletRequest request
                          , HttpServletResponse response
                          , Object handler
                          , ModelAndView modelAndView ) throws Exception {
        
         if (log.isDebugEnabled()) {
             log.debug("===== ===== ===== ===== =====     END     ===== ===== ===== ===== =====\n");
         }
    }
 
    @Override
    public void afterCompletion( HttpServletRequest request
                               , HttpServletResponse response
                               , Object handler
                               , Exception ex ) throws Exception {
    }
}
