package com.daeucna.board.security.service;
 
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.daeucna.board.security.dao.UserDao;
import com.daeucna.board.security.domain.UserForm;

import lombok.extern.slf4j.Slf4j;
 
@Slf4j
@Transactional(readOnly = true)
@Service
public class LoginService {
 
    @Autowired
    private UserDao userDao;
    @Autowired
    private BCryptPasswordEncoder bCryptPasswordEncoder;
 
    /** join 처리 */
    @Transactional(readOnly = false, propagation = Propagation.REQUIRED)
    public UserForm procJoin(UserForm userForm) throws Exception {
        int insertCnt = 0;
        //패스워드 암호화
        userForm.setJoinPass(bCryptPasswordEncoder.encode(userForm.getJoinPass()));
        
        insertCnt = userDao.insertUser(userForm);
 
        if (insertCnt > 0) {
        	userForm.setResult("SUCCESS");
        } else {
        	userForm.setResult("FAIL");
        }
        log.info("사용자등록 완료");
        return userForm;
    }

}
